#include "oled.h"
#include "stdlib.h" 
#include "delay.h"

u8 x_offset =0;



void Send_Byte(u8 dat)
{
	u8 i;
	for(i=0;i<8;i++)
	{
		OLED_SCL_Clr();
		if(dat&0x80)
		{
			OLED_SDA_Set();
		}
		else
		{
			OLED_SDA_Clr();
		}
		delay_us(3);
		OLED_SCL_Set();
		delay_us(3);
		OLED_SCL_Clr();
		dat<<=1;
	}
}

//ʼź
void I2C_Start(void)
{
	OLED_SDA_Set();
	OLED_SCL_Set();
	delay_us(3);
	OLED_SDA_Clr();
	delay_us(3);
	OLED_SCL_Clr();
	 
}

//ź
void I2C_Stop(void)
{
	OLED_SDA_Clr();
	OLED_SCL_Set();
	delay_us(5);
	OLED_SDA_Set();
}

//ȴźӦ
void I2C_WaitAck(void) //źŵĵƽ
{
	OLED_SDA_Set();
	delay_us(3);
	OLED_SCL_Set();
	delay_us(3);
	OLED_SCL_Clr();
	delay_us(3);
}


void Write_Command(unsigned char cmd)
{
	I2C_Start();
	Send_Byte(0x78);
	I2C_WaitAck();
	Send_Byte(0x00);
	I2C_WaitAck();
	Send_Byte(cmd);
	I2C_WaitAck();
	I2C_Stop();
}


void Write_Data(unsigned char Data)
{
	I2C_Start();
	Send_Byte(0x78);
	I2C_WaitAck();
	Send_Byte(0x40);
	I2C_WaitAck();
	Send_Byte(Data);
	I2C_WaitAck();
	I2C_Stop();
}



//ַΪ0
void OLED_Clear()
{
	Write_Command(0x01);			// Set Clear Display
}

//ʾת
void OLED_Display_Turn(u8 dat)
{
	if(dat==0)
	{
		x_offset=0;
		Write_Command(0x2A);   //REλΪ1
		Write_Command(0x06);   // SEG99->SEG0  	 COM0->COM31
	}
	else
	{
		//Ҫ4ַƫ
		x_offset=4;
		Write_Command(0x2A);   //REλΪ1
		Write_Command(0x05);   // SEG0->SEG99    COM31->COM0
	}
}


//Ļʾ
//dat:1 Ļʾ
//dat:0 رĻʾ
void OLED_Display_ON(u8 dat)
{
	if(dat)
	{
		Write_Command(0x28);
		Write_Command(0x0C);
	}
	else
	{
		Write_Command(0x28);
		Write_Command(0x08);
	}
}

//ַλʾ
//dat:0 
//dat:1 
void OLED_Display_Shift(u8 dat)
{
	if(dat)
	{
	 Write_Command(0x28);
	 Write_Command(0x1C);
	}
	else
	{
	 Write_Command(0x28);
	 Write_Command(0x18);
	}
}




//CGRAMλ
void OLED_CGRAM_Address(u8 CGaddr)
{
	Write_Command(0x28);
	Write_Command(0x40|(CGaddr<<3));
}

//ʾλ
//xеַ Χ0-40 Ļʾ16ַ
//yеַ Χ0-1
void OLED_DDRAM_Address(u8 x,u8 y)
{
	u8 addr=x_offset;
	addr+=x+y*0x40;
	Write_Command(0x28);
	Write_Command(0x80|addr);
}

//ʾԶ
//addr ʾλ
//CGaddr ԶCGRAMеλòΧ 
//Ҫ72Ĵֵȷ Ĭ0x00-0x07
//sysbolΪ Զȡģ
void OLED_Display_Custom(u8 x,u8 y,u8 CGaddr,u8 symbol[])
{
	u8 i;
	OLED_CGRAM_Address(CGaddr);
	for(i=0;i<8;i++)
	{
		Write_Data(symbol[i]);
	}
	OLED_DDRAM_Address(x,y);
	Write_Data(CGaddr);
}

//ʾַ
//x: еַ
//y: еַ
//chr:ʾַ
void OLED_ShowChar(u8 x,u8 y,u8 chr)
{
	OLED_DDRAM_Address(x,y);
	Write_Data(chr);
}

//ʾַ
//x: еַ
//y: еַ
//*str:ʾַ
void OLED_ShowString(u8 x,u8 y,u8 *str)
{
	OLED_DDRAM_Address(x,y);
	while(*str!='\0')
	{
		Write_Data(*str++);
	}
}

//51ƬҪע
u32 oled_pow(u8 m,u8 n)
{
	u32 result=1;
	while(n--) result*=m;
	return result;
}


//ʾ
//x: еַ
//y: еַ
//num:ʾֵ
//len:ʾλ
void OLED_ShowIntNum(u8 x,u8 y,u32 num,u8 len)
{
	u8 i,enshow=0;
	u32 temp;
	for(i=0;i<len;i++)
	{
		temp=(num/oled_pow(10,len-i-1))%10;
		if(enshow==0&&i<(len-1))
		{
			if(temp==0)
			{
				OLED_ShowChar(x,y,'0');
			}
			else
			{
				enshow=1;
			}
		}
		OLED_ShowChar(x+i,y,temp+'0');
	}
}

//ʾ
//x: еַ
//y: еַ
//num:ʾ
//len:ʾλС
//pre:ʾȾ
void OLED_ShowFloatNum(u8 x,u8 y,float num,u8 len,u8 pre)
{
	u32 i,temp,num1;
	num1=num*oled_pow(10,pre);
	for(i=0;i<len;i++)
	{
		temp=(num1/oled_pow(10,len-i-1))%10;
		if(i==(len-pre))
		{
				OLED_ShowChar(x+(len-pre),y,'.');
		    i++;
			  len+=1;
		}
		OLED_ShowChar(x+i,y,temp+'0');
	}
}




//ùʾ
//x: еַ
//y: еַ
//mode: 0رչ˸ 1 ù˸
//dat: 0 رչ    1 
void OLED_Display_Cursor(u8 x,u8 y,u8 mode,u8 dat)
{
	Write_Command(0x02);//ַλ
	if(dat)
	{
	 OLED_DDRAM_Address(x,y);
	 Write_Command(0x28);	
	 if(mode)
	 {
	  Write_Command(0x0F);
	 }
	 else
	 {		
	  Write_Command(0x0E);
	 }
	}
	else
	{
		Write_Command(0x28);
		Write_Command(0x0C);
	}
}


//OLEDʼ
void OLED_Init()
{
	GPIO_InitTypeDef  GPIO_InitStructure;
 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);	 //ʹA˿ʱ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOA, &GPIO_InitStructure);	  //ʼGPIOA
 	GPIO_SetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2);
	
//	OLED_RES_Clr();
//	delay_ms(200);
//	OLED_RES_Set();
	
	Write_Command(0x2A);
	Write_Command(0x71); //5V IO
	Write_Data(0x00);
	Write_Command(0x28);
	Write_Command(0x08);
	Write_Command(0x2A);
	Write_Command(0x79);
	Write_Command(0xD5);
	Write_Command(0x70);
	Write_Command(0x78);
	Write_Command(0x08);
	Write_Command(0x06);
	Write_Command(0x72);  //CGROMԼCGRAMֽ ԼַROMѡ
	Write_Data(0x05);   
	Write_Command(0x2A);
	Write_Command(0x79);
	Write_Command(0xDA);
	Write_Command(0x10);		
	Write_Command(0xDC);
	Write_Command(0x80);				
	Write_Command(0x81);
	Write_Command(0x8F);
	Write_Command(0xD9);
	Write_Command(0xF1);
	Write_Command(0xDB);
	Write_Command(0x30);  
	Write_Command(0x78);	// Set Extension Register "SD" as 0
	Write_Command(0x28);	// Set Extension Register "RE" as 0
	OLED_Clear();
	Write_Command(0x80);	
	Write_Command(0x0C);
}

